#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

enum state { UNVISITED, SEEN, VISITED };

int main ()
{
  int N, M;
  scanf("%d %d", &N, &M);

  vector<int> neighbors[N+1];

  for (int i=0; i<M; i++) {
    int u, v;
    scanf("%d %d", &u, &v);
    neighbors[u].push_back(v);
    neighbors[v].push_back(u);
  }

  // BFS scanning from 1
  queue<int> Q;
  vector<int> p(N+1);
  vector<state> m(N+1);
  Q.push(1);
  m[1] = SEEN;
  while (!Q.empty()) {
    int u = Q.front();
    Q.pop();
    m[u] = VISITED;
#if 0
    for (vector<int>::iterator i = neighbors[u].begin();
         i != neighbors[u].end(); i++)
      if (m[*i] == UNVISITED) {
        Q.push(*i);
        m[*i] = SEEN;
        p[*i] = u;
      }
#else
    for (int k=0; k < neighbors[u].size(); k++) {
      int v = neighbors[u][k];
      if (m[v] == UNVISITED) {
        Q.push(v);
        m[v] = SEEN;
        p[v] = u;
      }
    }
#endif
  }

  for (int i=1; i<=N; i++)
    printf("parent of %d is %d\n", i, p[i]);
  
  return 0;
}
