#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

vector< vector<int> > neighbors;
vector<int> p;
enum state { UNVISITED, SEEN, VISITED };
vector<state> m;

void dfs (int u)
{
  m[u] = SEEN;
  for (vector<int>::iterator i = neighbors[u].begin();
       i != neighbors[u].end(); i++)
    if (m[*i] == UNVISITED) {
      p[*i] = u;
      dfs(*i);
    }
  m[u] = VISITED;
}

int main ()
{
  int N, M;
  scanf("%d %d", &N, &M);

  neighbors.resize(N+1);

  for (int i=0; i<M; i++) {
    int u, v;
    scanf("%d %d", &u, &v);
    neighbors[u].push_back(v);
    neighbors[v].push_back(u);
  }

  // DFS scanning from all possible starts
  p.resize(N+1);
  m.resize(N+1);
  for (int i=1; i<=N; i++)
    if (m[i] == UNVISITED)
      dfs(i);

  for (int i=1; i<=N; i++)
    printf("parent of %d is %d\n", i, p[i]);
  
  return 0;
}
